/**
 * [crypto description]
 * @type {[type]}
 */

const crypto = require('crypto');


function myBase64Encode(buffer) {
    let result = buffer.replace(/\+/g, '-').replace(/\//g, '_').replace(/=+$/, '');

    return result;
}

/**
 * [url safe base64 decode]
 * @param  {[type]} buffer [description]
 * @return {[type]}        [description]
 */
function myBase64Decode(encode) {
    let base64 = '';

    if (!encode) {
        return base64;
    }

    base64 = encode.replace(/\-/g, '+').replace(/\_/g, '/');
    base64 += Array(5 - base64.length % 4).join('=');

    return base64;
}

exports.Encode = (key, str) => {
    let iv = key.substr(0, 16);

    let cipher = crypto.createCipheriv('aes-256-cbc', key, iv);

    let crypted = cipher.update(str, 'utf8', 'base64');
    crypted += cipher.final('base64');

    return myBase64Encode(crypted);
}



