/**
 * process
 */
const urlParse = require('url');
const config = require('./config');
const encry = require('./encry');
const _ = require('underscore');


class EncryPro {
    constructor() {
        this.conf = config;
        this.encry = encry.Encode;
        this.config = {};
    }

    configuration(url, dir, callback) {
        let query = urlParse.parse(url, true).query;
        let _this = this;

        let configFile = query.sys + '_config.json';

        this.conf.Config(configFile, url, dir, (res_conf) => {
            if (!res_conf.error) {
                _this.config[query.sys] = require('../' + configFile);
                callback(res_conf);
            } else {
                callback({
                    error: res_conf.error
                });
            }
        });
    }

    check(objin, obj, e, es) {
        let keyin = Object.keys(objin);
        let key = Object.keys(obj);

        let checked1 = (-1 == _.indexOf(es, e)) ? true : false;
        let checked2 = ((0 != _.difference(keyin, key).length) || (0 != _.difference(key, keyin).length)) ? true : false;

        if (!checked1 && !checked2) {
            return false;
        }

        return true;
    }

    encode(sys, event, obj, callback) {
        let config = this.config[sys] || {};

        if ((0 == Object.keys(config.data || []).length) || (!config.Key) || (!config.Event)) {
            callback({
                error: 'configuration is not okay',
                config: config
            });
        } else {
            let isCheck = this.check(config.data, obj, event, config.Event);
            if (isCheck) {
                callback({
                    error: 'parms is error',
                    event: config.Event,
                    data: config.data
                });
            } else {
                let zpp = this.encry(config.Key, JSON.stringify(obj));
                let genurl = config.Host + '?s=' + config.System + '&t=' + event + '&z=' + zpp;
                if (config.Tail) {
                    genurl += '&' + config.Tail;
                }

                callback({
                    data: genurl
                });
            }
        }
    }
}


module.exports = new EncryPro();
